[@foal/core](../README.md) > ["openapi/interfaces"](../modules/_openapi_interfaces_.md) > [IApiContact](../interfaces/_openapi_interfaces_.iapicontact.md)

# Interface: IApiContact

Contact information for the exposed API.

Source: [https://github.com/OAI/OpenAPI-Specification/blob/master/versions/3.0.2.md](https://github.com/OAI/OpenAPI-Specification/blob/master/versions/3.0.2.md)

*__export__*: 

*__interface__*: IApiContact

## Hierarchy

**IApiContact**

## Index

### Properties

* [email](_openapi_interfaces_.iapicontact.md#email)
* [name](_openapi_interfaces_.iapicontact.md#name)
* [url](_openapi_interfaces_.iapicontact.md#url)

---

## Properties

<a id="email"></a>

### `<Optional>` email

**● email**: *`undefined` \| `string`*

*Defined in [openapi/interfaces.ts:201](https://github.com/FoalTS/foal/blob/cf326d07/packages/core/src/openapi/interfaces.ts#L201)*

The email address of the contact person/organization. MUST be in the format of an email address.

Source: [https://github.com/OAI/OpenAPI-Specification/blob/master/versions/3.0.2.md](https://github.com/OAI/OpenAPI-Specification/blob/master/versions/3.0.2.md)

*__type__*: {string}

*__memberof__*: IApiContact

___
<a id="name"></a>

### `<Optional>` name

**● name**: *`undefined` \| `string`*

*Defined in [openapi/interfaces.ts:182](https://github.com/FoalTS/foal/blob/cf326d07/packages/core/src/openapi/interfaces.ts#L182)*

The identifying name of the contact person/organization.

Source: [https://github.com/OAI/OpenAPI-Specification/blob/master/versions/3.0.2.md](https://github.com/OAI/OpenAPI-Specification/blob/master/versions/3.0.2.md)

*__type__*: {string}

*__memberof__*: IApiContact

___
<a id="url"></a>

### `<Optional>` url

**● url**: *`undefined` \| `string`*

*Defined in [openapi/interfaces.ts:191](https://github.com/FoalTS/foal/blob/cf326d07/packages/core/src/openapi/interfaces.ts#L191)*

The URL pointing to the contact information. MUST be in the format of a URL.

Source: [https://github.com/OAI/OpenAPI-Specification/blob/master/versions/3.0.2.md](https://github.com/OAI/OpenAPI-Specification/blob/master/versions/3.0.2.md)

*__type__*: {string}

*__memberof__*: IApiContact

___

