[@foal/core](../README.md) > ["openapi/interfaces"](../modules/_openapi_interfaces_.md) > [IApiHttpSecurityScheme](../interfaces/_openapi_interfaces_.iapihttpsecurityscheme.md)

# Interface: IApiHttpSecurityScheme

## Hierarchy

 [IApiAbstractSecurityScheme](_openapi_interfaces_.iapiabstractsecurityscheme.md)

**↳ IApiHttpSecurityScheme**

## Index

### Properties

* [bearerFormat](_openapi_interfaces_.iapihttpsecurityscheme.md#bearerformat)
* [description](_openapi_interfaces_.iapihttpsecurityscheme.md#description)
* [scheme](_openapi_interfaces_.iapihttpsecurityscheme.md#scheme)
* [type](_openapi_interfaces_.iapihttpsecurityscheme.md#type)

---

## Properties

<a id="bearerformat"></a>

### `<Optional>` bearerFormat

**● bearerFormat**: *`undefined` \| `string`*

*Defined in [openapi/interfaces.ts:1923](https://github.com/FoalTS/foal/blob/cf326d07/packages/core/src/openapi/interfaces.ts#L1923)*

A hint to the client to identify how the bearer token is formatted. Bearer tokens are usually generated by an authorization server, so this information is primarily for documentation purposes.

Source: [https://github.com/OAI/OpenAPI-Specification/blob/master/versions/3.0.2.md](https://github.com/OAI/OpenAPI-Specification/blob/master/versions/3.0.2.md)

*__type__*: {string}

*__memberof__*: IApiHttpSecurityScheme

___
<a id="description"></a>

### `<Optional>` description

**● description**: *`undefined` \| `string`*

*Inherited from [IApiAbstractSecurityScheme](_openapi_interfaces_.iapiabstractsecurityscheme.md).[description](_openapi_interfaces_.iapiabstractsecurityscheme.md#description)*

*Defined in [openapi/interfaces.ts:1876](https://github.com/FoalTS/foal/blob/cf326d07/packages/core/src/openapi/interfaces.ts#L1876)*

A short description for security scheme. CommonMark syntax MAY be used for rich text representation.

Source: [https://github.com/OAI/OpenAPI-Specification/blob/master/versions/3.0.2.md](https://github.com/OAI/OpenAPI-Specification/blob/master/versions/3.0.2.md)

*__type__*: {string}

*__memberof__*: IApiAbstractSecurityScheme

___
<a id="scheme"></a>

###  scheme

**● scheme**: *`string`*

*Defined in [openapi/interfaces.ts:1912](https://github.com/FoalTS/foal/blob/cf326d07/packages/core/src/openapi/interfaces.ts#L1912)*

The name of the HTTP Authorization scheme to be used in the Authorization header as defined in RFC7235.

Source: [https://github.com/OAI/OpenAPI-Specification/blob/master/versions/3.0.2.md](https://github.com/OAI/OpenAPI-Specification/blob/master/versions/3.0.2.md)

*__type__*: {string}

*__memberof__*: IApiHttpSecurityScheme

___
<a id="type"></a>

###  type

**● type**: *"http"*

*Overrides [IApiAbstractSecurityScheme](_openapi_interfaces_.iapiabstractsecurityscheme.md).[type](_openapi_interfaces_.iapiabstractsecurityscheme.md#type)*

*Defined in [openapi/interfaces.ts:1902](https://github.com/FoalTS/foal/blob/cf326d07/packages/core/src/openapi/interfaces.ts#L1902)*

___

